--Tests for numavi.cpkg
Package $apcocoa/ts/numavi


Define Initialize()
EndDefine;


--AVI
Define TestNumAVI01()

TestRing::=QQ[x,y,z];

Using TestRing Do

  Points := Mat([[1,0,0],[0,0,1],[0,1,0]]);
  Result := Num.AVI(Points,0.001);
  Expected:=NewList(2);
  Expected[1] := [x + 1000799917193443/1000799917193444y + 1501199875790165/1501199875790166z - 2251799813685248/2251799813685249, xy, y^2 - y, xz, yz, z^2 - z];
  Expected[2] := [1, z, y];

  For I:=1 To Len(Expected) Do
    $apcocoa/ts/assert.AssertEqualsListOfNumericalPoly(Result[I], Expected[I], 0.1, "Polynomial "+Sprint(I)+" is wrong!");
  EndFor;

EndUsing;

EndDefine;



--BBasisOfPointsInIdealAVI
Define TestNumAVI02()

TestRing::=QQ[x,y,z];

Using TestRing Do

  Points := Mat([[2/3,0,0],[0,1,0],[0,0,1/3]]);
  Result := Num.SubAVI(Points, 0.1, [1,x]);
  Expected:=NewList(2);
  Expected[1] := [x + 2474467938458868/3711701907688301y + 7423403815376606/3711701907688301z - 4948935876917735/7423403815376602, xy, y^2 - 2123017224175257/2123017224175258y, xz, yz, z^2 - 5696652996790543/17089958990371628z];
  Expected[2] := [1, z, y];

  For I:=1 To Len(Expected) Do
    $apcocoa/ts/assert.AssertEqualsListOfNumericalPoly(Result[I], Expected[I], 0.1, "Polynomial "+Sprint(I)+" is wrong!");
  EndFor;  
  
EndUsing;

EndDefine;



--ProjectAVI
Define TestNumAVI03()

TestRing::=QQ[x,y,z];

Using TestRing Do
  Result := Num.ProjectAVI([[1,1],[0,1],[1,1]],[[0],[1],[0]],[x,y]);
  Expected := -4503599627370495/4503599627370496x + y;
  $apcocoa/ts/assert.AssertEqualsNumericalPoly(Result[1], Expected, 0.1, "Polynomial is wrong!");
  
EndUsing;

EndDefine;



-- IsAVI
Define TestNumAVI04()

TestRing::=QQ[x,y,z];

Using TestRing Do

  Result:=Num.IsAVI([x+1,x^2],[[0]],0.1);
  Expected:=[1592262918131443/2251799813685248, 1592262918131443/2251799813685248];
  For I:=1 To Len(Expected) Do
    $apcocoa/ts/assert.AssertEqualsNumericalNumber(Result[I],Expected[I],0.1, "Entry"+Sprint(I)+"is wrong IsAVI value!");
  EndFor;

EndUsing;

EndDefine;



--IsAppBB
Define TestNumAVI05()

TestRing::=QQ[x,y];

Using TestRing Do

  Res := Num.AVI([[1,1],[0,1]],0);
  Result:=Num.IsAppBB(Res[1],Res[2],0.1);
  Expected:=0;
  $apcocoa/ts/assert.AssertEqualsExact(Result,Expected, "Wrong IsAppBB value!");

EndUsing;

EndDefine;



--ContainsLinearRelations
Define TestNumAVI06()

TestRing::=QQ[x,y,z];

Using TestRing Do

  Result:=Num.ContainsLinearRelations([[1,1],[2,1]],[1,x],0.9);
  $apcocoa/ts/assert.AssertTrue(Result, "Wrong value!");

EndUsing;

EndDefine;

EndPackage;