-- This file represents a template for an apcocoa test package.
-- Here you write down all your tests for the package you want to test.
Package $apcocoa/ts/template

Define Initialize()
-- e.g. initialize variables, that you want to use for all of your tests
EndDefine;

-- (1) Define a function for every test you want to realize.
-- (2) Name the functions as follows: Test<PackageName><MyTestName>()
--     (you can find examples below or in the other already existing .ts packages)
-- (3) Every function realizes EXACTLY one test.
-- (5) A test can FAIL or SUCEED. The test fails iff the test functions
--     throws an error. To this end, use the AssertXY functions defined in XXX
--     as much as is sensible.
--     Note, that your test functions do not return anything.
-- (6) If you miss some AssertXY function, add it to assert.cpkg.
-- (4) You are free to add an arbitrary number of helper functions, 
--     just make sure that their names DO NOT start with 'Test'.
-- (5) To run all the tests defined in the package, call
--       $apcocoa/ts/aunit.RegisterTests("template");
--       $apcocoa/ts/aunit.RunTests();
--     To run just a single test, call
--       TODO - see TODO "naming convention" above.
Define TestTemplate01()

  TestRing::=QQ[x,y,z];

  Using TestRing Do

    $apcocoa/ts/assert.IsTrue(x=x, "x does not equal x.");

  EndUsing;

EndDefine;



Define TestTemplate02()

  TestRing::=ZZ/(2)[x[1..5]];

  Using TestRing Do

    -- implementation of the test

  EndUsing;

EndDefine;

-- TestTemplate03() and so on..

EndPackage;