/**************************************************************************
 * This file is part of the source of ApCoCoA Eclipse Plugin Project 
 * (Moccha).
 *
 *  Copyright (c) 2009 Stefan Schuster
 *
 * Visit http://apcocoa.org/ for more information regarding ApCoCoA
 * and ApCoCoALib.
 * Visit http://www.apcocoa.org/wiki/ApCoCoA:KnownIssues for bugs, problems 
 * and known issues.
 *
 * Moccha is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3 or later)
 * as published by the Free Software Foundation. A copy of the full
 * licence may be found in the file COPYING in this directory.
 *
 * Moccha is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Moccha; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 **************************************************************************/
package org.apcocoa.eclipse;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleConstants;

public class ApCoCoAPerspectiveFactory implements IPerspectiveFactory {

	public ApCoCoAPerspectiveFactory() {
		super();
	}
	
	public void createInitialLayout(IPageLayout layout) {
		// System.out.println("createInitialLayout called");
		String editorArea = layout.getEditorArea();
		layout.addView(IPageLayout.ID_RES_NAV, IPageLayout.LEFT, (float)0.3, editorArea);
		
		IFolderLayout topLeft = layout.createFolder("topleft", IPageLayout.TOP, (float)0.5, editorArea);
		topLeft.addView(IConsoleConstants.ID_CONSOLE_VIEW);
		
		
		/* IFolderLayout topRight = layout.createFolder("topright", IPageLayout.RIGHT, (float)0.5, "topleft");
		topRight.addView(IConsoleConstants.ID_CONSOLE_VIEW); */
		
		layout.addActionSet(IPageLayout.ID_NAVIGATE_ACTION_SET);
		
		layout.addNewWizardShortcut("org.eclipse.ui.wizards.new.folder");//$NON-NLS-1$
		layout.addNewWizardShortcut("org.eclipse.ui.wizards.new.file");//$NON-NLS-1$
		layout.addPerspectiveShortcut(IApCoCoAConstants.APCOCOA_PERSPECTIVE_ID);
	}
}
