package org.apcocoa.eclipse;

/**
 * The ApCoCoA Eclipse GUI heavily depends on "external contribution"
 * such as the CoCoA interpreter, the ApCoCoAServer, the packages directory
 * which is parsed to support code completion etc.
 * 
 * These external contributions are supplied as plug-ins extending the 
 * Extension Point 
 * org.apcocoa.external.contribution
 * 
 * This interface defines the basic methods that should be implemented
 * by an accompanying class can register the necessary paths etc.
 * 
 * @author Stefan Schuster
 *
 */
public interface IExternalContribution {

	public static String PROPERTY_COCOA_TEXT_PATH 		= "org.apcocoa.path.cocoa_text";
	
	public static String PROPERTY_APCOCOA_SERVER_PATH 	= "org.apcocoa.path.apcocoa_server";
	
	public static String PROPERTY_PACKAGES_PATH 		= "org.apcocoa.path.packages";
	
	public static String PROPERTY_WORDLIST_PATH 		= "org.apcocoa.path.wordlist";
	
	public static String PROPERTY_COCOARC_PATH 			= "org.apcocoa.path.cocoarc";
	
	public String getInfo();
	
	public String getPluginLocation();
	
	public String getPathFor(String key);
	
}
