package org.apcocoa.eclipse.cocoawrapper;

import java.util.Map;

import org.eclipse.cdt.utils.spawner.Spawner;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.model.IStreamsProxy;
import org.eclipse.debug.core.model.RuntimeProcess;

public class ExtendedProcess extends RuntimeProcess {

	
	private boolean enableStreamsProxy = false;
	
	public ExtendedProcess(ILaunch launch, Process process, String name,
			Map attributes) {
		super(launch, process, name, attributes);
		enableStreamsProxy = true;
		// TODO Auto-generated constructor stub
	}
	
	public IStreamsProxy getStreamsProxy() {

		if (!enableStreamsProxy) {

			return null;
		}
		return super.getStreamsProxy();
	}
	
	/**
	 * Sends a <code>SIGINT</code> signal to the underlying system {@link Process}. This is roughly
	 * equivalent to the user pressing Ctrl-C.
	 *
	 * @return <code>true</code> if the interrupt signal was sent successfully; <code>false</code>
	 * if the signal was not sent successfully or if no signal was sent because the underlying
	 * process is not a CDT {@link Spawner}
	 */
	public boolean interrupt() {

		Process process = getSystemProcess();
		if (process instanceof Spawner) {

			return ((Spawner)process).interrupt() == 0;
		} else
			System.out.println("CoCoA process was not a Spawner!!");
		return false;
	}

}
