package org.apcocoa.eclipse.editors;

import org.apcocoa.eclipse.ApCoCoAPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentPartitioner;
import org.eclipse.jface.text.rules.FastPartitioner;
import org.eclipse.ui.editors.text.TextFileDocumentProvider;

public class ApCoCoAStorageDocumentProvider extends TextFileDocumentProvider {
	protected FileInfo createFileInfo(Object element) throws CoreException {
		ApCoCoAPlugin.debugLog("StorageDocumentProvider");
        FileInfo info = super.createFileInfo(element);
        if(info==null){
                info = createEmptyFileInfo();
        }
        IDocument document = info.fTextFileBuffer.getDocument();
        if (document != null) {
        	IDocumentPartitioner partitioner =
				new FastPartitioner(
					new ApCoCoAPartitionScanner(),
					new String[] {
						IDocument.DEFAULT_CONTENT_TYPE,
						ApCoCoAPartitionScanner.APCOCOA_COMMENT });
			partitioner.connect(document);
			document.setDocumentPartitioner(partitioner);
        }
        return info;
    }

}
