/**************************************************************************
 * This file is part of the source of ApCoCoA Eclipse Plugin Project 
 * (Moccha).
 *
 *  Copyright (c) 2009 Stefan Schuster
 *
 * Visit http://apcocoa.org/ for more information regarding ApCoCoA
 * and ApCoCoALib.
 * Visit http://www.apcocoa.org/wiki/ApCoCoA:KnownIssues for bugs, problems 
 * and known issues.
 *
 * Moccha is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3 or later)
 * as published by the Free Software Foundation. A copy of the full
 * licence may be found in the file COPYING in this directory.
 *
 * Moccha is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Moccha; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 **************************************************************************/
package org.apcocoa.eclipse.handlers;

import org.apcocoa.eclipse.ApCoCoAPlugin;
import org.apcocoa.eclipse.cocoawrapper.CoCoAProcess;
import org.apcocoa.eclipse.cocoawrapper.CoCoAProcessManager;
import org.apcocoa.eclipse.console.ApCoCoAConsole;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.commands.IHandlerListener;
import org.eclipse.jface.resource.JFaceResources;

public class RestartApCoCoAHandler extends AbstractHandler {

	public RestartApCoCoAHandler() {
	}
	
	public Object execute(ExecutionEvent event) throws ExecutionException {
		// Synchronize with GUI in order to prevent a hanging Eclipse.
		synchronized (ApCoCoAPlugin.getPlugin().getWorkbench()) {
			CoCoAProcessManager.getCoCoAProcessManager().restartApCoCoA();
			
			/* ApCoCoAPlugin.getStandardDisplay().asyncExec(new Runnable() {
				public void run() {
					CoCoAProcessManager.restartApCoCoA();
				}
			}); */
			
			return null;
		}
	}
}
