package org.apcocoa.eclipse.handlers;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import org.apcocoa.eclipse.ApCoCoAPlugin;
import org.apcocoa.eclipse.console.ApCoCoAConsole;
import org.apcocoa.eclipse.console.ConsoleDocument;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.commands.IHandlerListener;
import org.eclipse.debug.internal.ui.views.console.ConsoleLineNotifier;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.handlers.HandlerUtil;

public class SaveConsoleToFileHandler implements IHandler {

	public SaveConsoleToFileHandler() {
		
	}
	
	public void addHandlerListener(IHandlerListener handlerListener) {
		// TODO Auto-generated method stub

	}

	public void dispose() {
		// TODO Auto-generated method stub

	}

	public Object execute(ExecutionEvent event) throws ExecutionException {
		
		ApCoCoAPlugin.debugLog("Saving console content to file.");
		ApCoCoAConsole console = ApCoCoAPlugin.getPlugin().getConsole();
		String contentToSave = console.getDocument().get();
		
		IWorkbenchWindow window = HandlerUtil.getActiveWorkbenchWindowChecked(event);
		IWorkbenchPage page = window.getActivePage();
		Shell shell = page.getWorkbenchWindow().getShell();
		
		FileDialog dialog = new FileDialog(shell, SWT.SAVE);
		dialog.setText("Save ApCoCoA output as");
		dialog.setFilterExtensions(new String[] {"*.out", "*.*"});
		dialog.setFileName("output.out");
		String filename = dialog.open();
		if (filename != null) {
			File newFile = new File(filename);
			boolean doWrite = true;
			if (newFile.exists()) {
				doWrite = MessageDialog.openQuestion(shell, 
						"Owerwrite file?", 
						"File " + newFile.getName() + " already exists."
						+ "\nDo you want to overwrite it?");
			}
			if (doWrite) {	
				try {
					BufferedWriter writer = new BufferedWriter(new FileWriter(newFile));
					writer.write(contentToSave);
					writer.close();
				} catch (IOException e) {
					MessageDialog.openError(shell, 
							"Error", 
							"Could not write file " + newFile.getName() + ".");
				}
			}
		}
		return null;
	}

	public boolean isEnabled() {
		// TODO Auto-generated method stub
		return true;
	}

	public boolean isHandled() {
		// TODO Auto-generated method stub
		return true;
	}

	public void removeHandlerListener(IHandlerListener handlerListener) {
		// TODO Auto-generated method stub

	}

}
