

package org.apcocoa.eclipse.templates;

import java.util.ArrayList;
import java.util.List;

import org.apcocoa.eclipse.ApCoCoAPlugin;
import org.apcocoa.eclipse.core.ApCoCoASelection;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.ITextViewer;
import org.eclipse.jface.text.contentassist.ICompletionProposal;
import org.eclipse.jface.text.templates.Template;
import org.eclipse.jface.text.templates.TemplateCompletionProcessor;
import org.eclipse.jface.text.templates.TemplateContext;
import org.eclipse.jface.text.templates.TemplateContextType;
import org.eclipse.swt.graphics.Image;

/**
 * 
 * Copied from net.sourceforge.texlipse.templates.TexTemplateCompletion and
 * org.python.pydev.editor.codecompletion.templates.PyTemplateCompletionProcessor
 *
 */
public class ApCoCoATemplateCompletionProcessor extends TemplateCompletionProcessor {

	TemplateContextType context;
	
	@Override
	protected TemplateContextType getContextType(ITextViewer viewer,
			IRegion region) {
		return ApCoCoAPlugin.getApCoCoAContextTypeRegistry().getContextType(ApCoCoAContextType.AC_CONTEXT_TYPE);
	}

	@Override
	protected Image getImage(Template template) {
		// TODO Auto-generated method stub
		return null;
	}

	
    
    /**
     * Overridden so that we can do the indentation in this case.
     */
    @Override
    protected TemplateContext createContext(final ITextViewer viewer, final IRegion region) {
        TemplateContextType contextType= getContextType(viewer, region);
        return createContext(contextType, viewer, region);
    }
    
    /**
     * Creates a concrete template context for the given region in the document. This involves finding out which
     * context type is valid at the given location, and then creating a context of this type. The default implementation
     * returns a <code>DocumentTemplateContext</code> for the context type at the given location.
     *
     * @param contextType the context type for the template.
     * @param viewer the viewer for which the context is created
     * @param region the region into <code>document</code> for which the context is created
     * @return a template context that can handle template insertion at the given location, or <code>null</code>
     */
    public static ApCoCoADocumentTemplateContext createContext(final TemplateContextType contextType, final ITextViewer viewer, final IRegion region) {
        if (contextType != null) {
            IDocument document= viewer.getDocument();
            String indent = "";
            ApCoCoASelection selection = new ApCoCoASelection(document, viewer.getTextWidget().getSelection().x);
            indent = selection.getIndentationFromLine();
            
            final String indentTo = indent;
            
            return new ApCoCoADocumentTemplateContext(contextType, document, region.getOffset(), region.getLength(), indentTo, viewer);
        }
        return null;
    }
	
	@Override
	protected Template[] getTemplates(String contextTypeId) {
		return ApCoCoAPlugin.getApCoCoATemplateStore().getTemplates();
	}
	
	public void addTemplateProposals(ITextViewer viewer, int documentOffset,
             List<ICompletionProposal> proposals, String prefix) {
		// String prefix = extractPrefix(viewer, documentOffset);
		ICompletionProposal[] templateProposals = 
            computeCompletionProposals(viewer, documentOffset);
		for (int j = 0; j < templateProposals.length; j++) {
            if ( templateProposals[j].getDisplayString().toLowerCase().startsWith(prefix.toLowerCase())){
            	proposals.add(templateProposals[j]);
            }
        }
	}

}
