/**************************************************************************
 * This file is part of the source of ApCoCoA Eclipse Plugin Project 
 * (Moccha).
 *
 *  Copyright (c) 2009 Stefan Schuster
 *
 * Visit http://apcocoa.org/ for more information regarding ApCoCoA
 * and ApCoCoALib.
 * Visit http://www.apcocoa.org/wiki/ApCoCoA:KnownIssues for bugs, problems 
 * and known issues.
 *
 * Moccha is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3 or later)
 * as published by the Free Software Foundation. A copy of the full
 * licence may be found in the file COPYING in this directory.
 *
 * Moccha is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Moccha; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 **************************************************************************/
package zzunused;

import java.io.IOException;

import org.apcocoa.eclipse.ApCoCoAPlugin;
import org.eclipse.debug.core.model.IStreamMonitor;
import org.eclipse.debug.core.model.IStreamsProxy;

/**
 * @author  schuster
 */
public class ApCoCoAStreamsProxy implements IStreamsProxy {
	/**
	 * @uml.property  name="fErrorMonitor"
	 * @uml.associationEnd  
	 */
	private ApCoCoAStreamMonitor fErrorMonitor = new ApCoCoAStreamMonitor();
	/**
	 * @uml.property  name="fOutputMonitor"
	 * @uml.associationEnd  
	 */
	private ApCoCoAStreamMonitor fOutputMonitor = new ApCoCoAStreamMonitor();
	
	public static final String APCOCOA_DEBUG_STREAM = ApCoCoAPlugin.PLUGIN_ID + ".APCOCOA_DEBUG_STREAM"; //$NON-NLS-1$
	public static final String APCOCOA_VERBOSE_STREAM = ApCoCoAPlugin.PLUGIN_ID + ".APCOCOA_VERBOSE_STREAM"; //$NON-NLS-1$
	public static final String APCOCOA_WARNING_STREAM = ApCoCoAPlugin.PLUGIN_ID + ".APCOCOA_WARNING_STREAM"; //$NON-NLS-1$
	
	/**
	 * @uml.property  name="fDebugMonitor"
	 * @uml.associationEnd  
	 */
	private ApCoCoAStreamMonitor fDebugMonitor = new ApCoCoAStreamMonitor();
	/**
	 * @uml.property  name="fVerboseMonitor"
	 * @uml.associationEnd  
	 */
	private ApCoCoAStreamMonitor fVerboseMonitor = new ApCoCoAStreamMonitor();
	/**
	 * @uml.property  name="fWarningMonitor"
	 * @uml.associationEnd  
	 */
	private ApCoCoAStreamMonitor fWarningMonitor = new ApCoCoAStreamMonitor();

	/**
	 * @see org.eclipse.debug.core.model.IStreamsProxy#getErrorStreamMonitor()
	 */
	public IStreamMonitor getErrorStreamMonitor() {
		return fErrorMonitor;
	}

	/**
	 * @see org.eclipse.debug.core.model.IStreamsProxy#getOutputStreamMonitor()
	 */
	public IStreamMonitor getOutputStreamMonitor() {
		return fOutputMonitor;
	}

	/**
	 * @see org.eclipse.debug.core.model.IStreamsProxy#write(java.lang.String)
	 */
	public void write(String input) throws IOException {
	}

	public IStreamMonitor getWarningStreamMonitor() {
		return fWarningMonitor;
	}
	
	public IStreamMonitor getDebugStreamMonitor() {
		return fDebugMonitor;
	}	
	
	public IStreamMonitor getVerboseStreamMonitor() {
		return fVerboseMonitor;
	}	

}
