/**************************************************************************
 * This file is part of the source of ApCoCoA Eclipse Plugin Project 
 * (Moccha).
 *
 *  Copyright (c) 2009 Stefan Schuster
 *
 * Visit http://apcocoa.org/ for more information regarding ApCoCoA
 * and ApCoCoALib.
 * Visit http://www.apcocoa.org/wiki/ApCoCoA:KnownIssues for bugs, problems 
 * and known issues.
 *
 * Moccha is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3 or later)
 * as published by the Free Software Foundation. A copy of the full
 * licence may be found in the file COPYING in this directory.
 *
 * Moccha is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Moccha; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 **************************************************************************/
package zzunused;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;

import org.apcocoa.eclipse.ApCoCoAPlugin;
import org.apcocoa.eclipse.console.ApCoCoAConsole;

/**
 * @author  schuster
 */
public class OutputConsoleConnector extends Thread implements Runnable {
	private static int counter = 0;
	
	private BufferedInputStream bis = null;
	private InputStreamReader isr = null;
	private BufferedReader br = null;
	/**
	 * @uml.property  name="console"
	 * @uml.associationEnd  
	 */
	private ApCoCoAConsole console = null;
	
	private InputStream pi = null;
	private OutputStream po = null;
	private String process = null;
	private boolean stopped = false;

	
	OutputConsoleConnector(String process, InputStream processInput, ApCoCoAConsole console) {
		// this.bis = new BufferedInputStream(processInput);
		this.br = new BufferedReader(new InputStreamReader(processInput));
		this.console = console;
	}
	

	public void run() {
		ApCoCoAPlugin.debugLog("[OutputConsoleConnector.run]" + counter + "##"+ this.getId());
		int ch;
		byte[] buffer = new byte[512];
		int bytes_read;
		try {
			if (stopped)
				ApCoCoAPlugin.debugLog("[OuptutConnector.run]Stopped");
			else
				ApCoCoAPlugin.debugLog("[OuptutConnector.run]running");
			for (;!stopped;) {
				String s = br.readLine();
				// console.sendResponse(s);
//				bytes_read = pi.read(buffer);
//				if (bytes_read == -1) {
//					ApCoCoAPlugin.debugLog("GOT -1 *************************" + counter + "##" + this.getId());
//					return;
//				}
//				po.write(buffer, 0, bytes_read);
//				po.flush();
			}
			ApCoCoAPlugin.debugLog("[OutputConnector.run] For loop ended." + counter + "##" + this.getId());
			return;
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
		}
	}
	
	public void detach() {
		ApCoCoAPlugin.debugLog("OutputConnecor.detach");
		this.stopped = true;
	}
}
